/*

        WAICOMUN.C

        Funciones y variables comunes a las
        versiones del Wailer para Windows.

        (C) 1993/1995 Angel Ortega

*/


/************************
        Variables
*************************/

/* respuestas en ANSI */
int RespuestaANSI=0;

/* flag de escritura: si es 0, se esta en modo lectura; si es 1,
   en modo escribir mensaje */
int Escr=0;

/* handler de esta instancia */
HANDLE hInst;

/* libreria de botones tipo icono ICONBUTT.C (C) Angel Ortega */
#include "iconbutt.c"

/* libreria de impresion WINPRINT.C (C) Angel Ortega */
#include "winprint.c"

/* procedimientos de edicion */
FARPROC lpOldEditProc;
FARPROC lpNewEditProc;


/************************
        Funciones
*************************/

int SomeToAnsi(LPSTR origen, LPSTR destino)
/* traduce del formato original a ANSI */
{
        if(strcmp(thisCharset, "US-ASCII")==0)
		OemToAnsi(origen, destino);

        return(-1);
}


void Reindex(void)
/* reordena ambos ndices */
{
	HCURSOR hcurSave;

	hcurSave = SetCursor(LoadCursor(NULL, IDC_WAIT));

	unlink(HISTO_IND);
	unlink(NUEVOS_IND);

	Index(NUEVOS_DAT, NUEVOS_IND);
	Index(HISTO_DAT, HISTO_IND);

	SetCursor(hcurSave);
}



void NewVersion(HWND hwnd, char * app)
/* controla nuevas versiones */
{
        if(app[0]=='*')
                MessageBox(hwnd, "Bienvenido a The Wailer!",
                        szApp, MB_OK);
        else
        {
                MessageBox(hwnd,"Bienvenido a una nueva versin de The Wailer!",
			szApp, MB_OK);

		/* en las nuevas versiones, se regeneran los ndices */
		Reindex();
	}
}


int InitWailer(HWND hwnd)
/* inicializa los ficheros */
{
        char tmp[150];
        char app[150];

        GetPrivateProfileString(APPGEN, "RespuestaAnsi","No",tmp,149,INI_FILE);
        if(tmp[0]=='S' || tmp[0]=='s')
                RespuestaANSI=1;

        GetPrivateProfileString(APPGEN,"FicheroMensajes",
                MSG_FILE,MSG_FILE,sizeof(MSG_FILE),INI_FILE);

        GetPrivateProfileString(APPGEN,"FicheroRespuestas",
                RESP_FILE,RESP_FILE,sizeof(RESP_FILE),INI_FILE);

        GetPrivateProfileString(APPGEN, "Yo","",Yo,29,INI_FILE);

        GetPrivateProfileString(APPGEN,"Guardar","S",tmp,
                sizeof(tmp)-1,INI_FILE);

        if(tmp[0]=='s' || tmp[0]=='S')
                use_histo=1;
        else
                use_histo=0;

        /* si no existe un fichero de mensajes... */
        if(!InitW())
        {
                /* se leen las cadenas de configuracion */
                GetPrivateProfileString(APPGEN,"VersionId","*",app,149,INI_FILE);

                /* si no coincide con la version actual... */
                if(strcmp(app,szApp)!=0)
                {
                        WritePrivateProfileString(APPGEN,"VersionId",szApp,INI_FILE);

                        NewVersion(hwnd, app);
                        return(0);
                }

                GetPrivateProfileString(APPGEN,"Historico","",tmp,149,INI_FILE);
                Histo=atoi(tmp);

                GetPrivateProfileString(APPGEN,"Conferencia","",tmp,149,INI_FILE);
                Conferencia=atoi(tmp);

                GetPrivateProfileString(APPGEN,"Mensaje","",tmp,149,INI_FILE);
                Mensaje=atol(tmp);

                if(Conferencia>=NumConfes)
                {
                        Conferencia=-1;
                        Mensaje=-1;
                }

                return(0);
        }

        if(MessageBox(hwnd, "Existe un nuevo fichero de mensajes.\nQuiere actualizar la base de datos?",
                szApp, MB_ICONQUESTION|MB_YESNO)==IDNO)
                return(0);

        ProcessNew();

		if(IsRespFile())
		{
        	if(MessageBox(hwnd, "Desea inicializar el fichero de respuestas?",
                szApp, MB_ICONQUESTION|MB_YESNO)==IDYES)
                InitRespFile();
		}

        return(1);
}




void EndWailer(void)
/* finaliza */
{
        char tmp[150];

        EndW();

        /* escribe la ultima posicion en el fichero de inicializacion */
        sprintf(tmp,"%d",Histo);
        WritePrivateProfileString(APPGEN, "Historico",tmp,INI_FILE);

        if(Conferencia==-1)
                Conferencia=0;
        sprintf(tmp,"%d",Conferencia);
        WritePrivateProfileString(APPGEN, "Conferencia",tmp,INI_FILE);

        sprintf(tmp,"%d",Mensaje);
        WritePrivateProfileString(APPGEN, "Mensaje",tmp,INI_FILE);
}


long FAR PASCAL NewEditProc(HWND hwnd, WORD msg, WORD wParam,
        LONG lParam)
/* nuevo procedimiento del gran control de edicin */
{
        /* si no est en modo escritura, se rechazan los WM_CHAR */
        if(!Escr)
        {
                if(msg==WM_CHAR)
                        return(0L);
                else
                {
                        /* si el foco es de la ventana de edicin,
                           se lo devuelve a la principal */
                        if(GetFocus()==hwnd)
                                SetFocus(GetParent(hwnd));
                }
        }

        return CallWindowProc(lpOldEditProc, hwnd, msg, wParam, lParam);
}


void ChangeEditProcs(HWND hwnd)
/* cambia los procedimientos de los cuadros de edicin */
{
        /* crea un procinstance */
        lpNewEditProc=MakeProcInstance ((FARPROC) NewEditProc, hInst);

        /* coge el antiguo y lo sustituye */
        lpOldEditProc=(FARPROC) SetWindowLong (hwnd,
                GWL_WNDPROC, (long) lpNewEditProc);
}


void PrintMsg(HWND hwnd)
/* imprime el mensaje en la caja de texto */
{
        HDC hdc;
        TEXTMETRIC tm;
        char str[256];
        int len;
        int nl;
        int n;
        int h;
        int lin;
        int x;
        int y;

        /* mximo de caracteres a leer */
        str[0]=0xFF;
        str[1]=0x00;

        if((hdc=OpenPrn())!=NULL)
        {
                /* coge la altura del carcter */
                GetTextMetrics(hdc, &tm);

                h=tm.tmHeight;

                BeginPrn(hdc,"Wailer");

                TamPagPrn(hdc, &x, &y);

                /* coge el nmero de lneas */
                nl=(int) SendMessage(hwnd,EM_GETLINECOUNT,0,0L);

                for(n=0,lin=0;n<nl;n++)
                {
                        len=(int) SendMessage(hwnd, EM_GETLINE,
                                (WORD) n, (LONG)(char far *) str)+2;

                        TextOut(hdc,0,lin*h,(LPSTR) str,len-2);

                        lin++;

                        if(lin*h>y)
                        {
                                FormFeedPrn(hdc);
                                lin=0;
                        }
                }

                ClosePrn(hdc);
        }
}
