/*

        WAILER2.C

	The Wailer 2.1.1. Lector de News.

	(C) Angel Ortega 1993/1995

*/

#define DEBUG

/** #includes standard **/
#include <windows.h>
#include <commdlg.h>
#include "..\ctl3d\ctl3d.h"

#include "wailer2.h"


/* nombre del programa con versin */
char szApp[]="The Wailer 2.1.1";

#include "waimotor.c"
#include "waicomun.c"

/** constantes **/
char * strFrameClass="WailerFrame";
char * strToolBoxClass="WailerToolBox";
char * strMsgClass="WailerMsg";
char * strRspClass="WailerRsp";
char * strLstClass="WailerLst";
char * strResClass="WailerRes";

char * szWinPos="Posiciones";

/** globales **/

/* handler del men */
HMENU hMenu;


/* handles de las ventanas: */

/* ventana marco */
HWND hwndFrame;
/* cliente MDI */
HWND hwndClient;
/* ventana de ToolBox */
HWND hwndToolBox=0;
/* ventana de mensaje */
HWND hwndMsg=0;
/* cuadro de texto del mensaje */
HWND hwndTexto=0;
/* cabecera del mensaje en ventana de mensaje */
HWND hwndCabecera=0;
/* ventana lista */
HWND hwndLst=0;
/* handler de la lista */
HWND hwndLista=0;
/* ventana de edicin de respuestas */
HWND hwndRes=0;

/* fonts */
/* normal */
HFONT nFont=0;
/* proporcional (pequeo) */
HFONT pFont=0;
/* fino (pequeo) */
HFONT tFont=0;
/* fixed (courier) */
HFONT fFont=0;


/* altura del font pequeo */
int AltpFont=0;


/* botones del toolbox */
struct
{
        WORD id;        /* identificativo del botn */
        char * icon;    /* nombre del icono */
        WORD idm;       /* opcin de men a la que equivale */
} tbb[]=
{
	TB_BORRAR,      "Borrar;Borrar mensaje.", IDM_BORRAR,
	TB_CONTESTAR,   "Contestar;Contestar al mensaje.", IDM_CONTESTAR,
        TB_ESCRIBIR,    "Escribir;Escribir mensaje nuevo.",IDM_ESCRIBIR,
        TB_ATRAS,       "Waiizqd;Conferencia anterior.",	IDM_ATRAS,
	TB_ACERCADE,    "Wailer;Acerca de 'The Wailer'.",	IDM_ACERCADE,
        TB_ADELANTE,    "Waidrch;Conferencia siguiente.",IDM_ADELANTE,
        TB_RET,         "Wairet;Mensaje anterior.",	IDM_RET,
	TB_PRN,         "Waifont;Cambiar a font no proporcional",IDM_FONT,
        TB_AVA,         "Waiava;Mensaje siguiente.",	IDM_AVA,
        TB_NUEVOS,      "Wainue;Nuevos mensajes.",	IDM_NUEVOS,
        TB_HISTORICO,   "Waihis;Histrico de mensajes.",	IDM_HISTORICO,
        TB_RESPUESTAS,  "Wairesp;Editar respuestas.",	IDM_RESPUESTAS,
        0,              "",             0,
        0,              "",             0,
        0,              "",             0
};


/* cabecera en mensaje s/no */
int MsgCab=0;

/* nmero secuencial de mensaje escrito */
int EscrMsgNum=1;

/* nmero de ventanas de escritura activas */
int NumResp=0;

/** prototipos **/
DWORD FAR PASCAL WailerFrameProc(HWND, WORD, WORD, DWORD);
DWORD FAR PASCAL WailerLstProc(HWND, WORD, WORD, DWORD);
DWORD FAR PASCAL WailerToolBoxProc(HWND, WORD, WORD, DWORD);
DWORD FAR PASCAL WailerMsgProc(HWND, WORD, WORD, DWORD);
DWORD FAR PASCAL WailerRspProc(HWND, WORD, WORD, DWORD);
DWORD FAR PASCAL WailerResProc(HWND, WORD, WORD, DWORD);
BOOL FAR PASCAL EditMimeProc(HWND hDlg, WORD message, WORD wParam, LONG lParam);


/* rectngulo para las posiciones de las ventanas */
RECT Wpos;

/* nmero de iconos por lnea en la toolbox */
int nbtb=3;

/* buffer */
char buffer[600];

/* texto de la lnea de mensaje */
char TxtLinMsg[150]="";

/* si AnySize es no cero, se permiten objetos MIME de cualquier tamao */
int AnySize=0;

/* estructura para los common dialogs */
OPENFILENAME ofn;


/** funciones **/

#ifdef DEBUG
        #define Assert(c) if(!(c)) MessageBox(NULL,#c,"Assertion Failed!",MB_OK)
#else
        #define Assert(c) (void)(0)
#endif


void SetTxtLinMsg(char * txtmsg)
/* define el texto que debe aparecer en la lnea de mensaje */
{
	strcpy(TxtLinMsg,txtmsg);
	InvalidateRect(hwndFrame,NULL,NULL);
}


void GetWpos(char * key)
/* lee sobre Wpos la posicin de la ventana descrita por key */
{
        char tmp[100];

        /* intenta leer la clave */
        GetPrivateProfileString(szWinPos, key, "*", tmp, 99, INI_FILE);

        if(tmp[0]=='*')
        {
                /* si no hay nada, se inicializa */
                Wpos.top=Wpos.left=Wpos.bottom=Wpos.right=CW_USEDEFAULT;
        }
        else
        {
                Wpos.left=atoi(strtok(tmp, ", "));

                Wpos.top=atoi(strtok(NULL, ", "));

                Wpos.right=atoi(strtok(NULL, ", "))-Wpos.left;
                Wpos.bottom=atoi(strtok(NULL, ", "))-Wpos.top;

                if(strcmp(key,"Main")!=0)
                {
                        Wpos.top-=(GetSystemMetrics(SM_CYCAPTION)+
                                GetSystemMetrics(SM_CYMENU)+
                                GetSystemMetrics(SM_CYFRAME));

                        Wpos.left-=GetSystemMetrics(SM_CXFRAME);
                }
        }
}


void ProcessKeys(WORD wParam)
/* procesa las teclas pulsadas, enviando mensajes a los correspondientes
   mens */
{
        /* pulsaciones */

#ifdef DEBUGCHARS
	{
		char tmp[100];

		sprintf(tmp,"%X",wParam);
		MessageBox(NULL,tmp,tmp,MB_OK);
	}
#endif

        /* si se pulsa shift, los movimientos van para la lista */
        if(GetKeyState(VK_SHIFT)<0)
        {
                switch(wParam)
		{
                case VK_HOME:
                case VK_END:
                case VK_PRIOR:
                case VK_NEXT:
                case VK_UP:
                case VK_DOWN:

              		/* enva la tecla a la lista */
                        if(hwndLista)
				SendMessage(hwndLista, WM_KEYDOWN,
					wParam, 0L);

				break;
                }
        }
        else
        {
                switch(wParam)
                {
                /* hot-keys de cambio de font */
                case VK_DIVIDE:
                case VK_MULTIPLY:

			SendMessage(hwndFrame, WM_COMMAND, IDM_FONT, 0L);
                        break;

                /* se le mandan a la ventana de texto */
                case VK_UP:
                        SendMessage(hwndTexto, WM_VSCROLL, SB_LINEUP, 0L);
                        break;

                case VK_DOWN:
                        SendMessage(hwndTexto, WM_VSCROLL, SB_LINEDOWN, 0L);
                        break;

                case VK_LEFT:
                        SendMessage(hwndFrame, WM_COMMAND, IDM_RET, 0L);
                        break;

                case VK_RIGHT:
                        SendMessage(hwndFrame, WM_COMMAND, IDM_AVA, 0L);
                        break;

                case VK_PRIOR:
                        SendMessage(hwndTexto, WM_VSCROLL, SB_PAGEUP, 0L);
                        break;

                case VK_NEXT:
                        SendMessage(hwndTexto, WM_VSCROLL, SB_PAGEDOWN, 0L);
                        break;

                case VK_HOME:
			SendMessage(hwndTexto, WM_HSCROLL, SB_TOP, 0L);
                        break;

                case VK_END:
                        SendMessage(hwndTexto, WM_HSCROLL, SB_BOTTOM, 0L);
                        break;

		case VK_BACK:
		case VK_DELETE:
			/* Del y Backspc: hotkey,s. de borrar */
                        if(SendMessage(hwndFrame, WM_COMMAND, IDM_BORRAR, 0L)!=0L)
                        	SendMessage(hwndFrame, WM_COMMAND, IDM_ADELANTE, 0L);

                        break;

                case VK_INSERT:
                        /* escribe un mensaje */
                        SendMessage(hwndFrame, WM_COMMAND, IDM_ESCRIBIR, 0L);
                        break;

                case VK_RETURN:
                        /* contesta un mensaje */
                        SendMessage(hwndFrame, WM_COMMAND, IDM_CONTESTAR, 0L);
                        break;

                case VK_ADD:
                        /* adelante conferencia */
                        SendMessage(hwndFrame, WM_COMMAND, IDM_ADELANTE, 0L);
                        break;

                case VK_SUBTRACT:
                        /* atrs conferencia */
                        SendMessage(hwndFrame, WM_COMMAND, IDM_ATRAS, 0L);
                        break;

		case 0x13:
			/* tecla del jefe: iconiza inmediatamente */
                        SendMessage(hwndFrame, WM_SYSCOMMAND, SC_MINIMIZE, 0L);
                }
        }
}


void Stop(void)
/* muestra una MessageBox en desarrollo */
{
        MessageBox(NULL, "Opcin en Desarrollo.", szApp, MB_OK);
}


void BuildFonts(void)
/* crea los fonts */
{
        LOGFONT lf;
        short int t;
        char font[100];

	/* escoge el fuente por defecto segn la resolucin del sistema */
        switch(GetSystemMetrics(SM_CXSCREEN))
        {
        case 800:
		strcpy(font, "Arial,17");
                break;

        case 1024:
                strcpy(font, "Arial,22");
                break;

        default:
                strcpy(font, "MS Sans Serif,15");
		break;
        }

        /* se lee la informacin Font de WAILER.INI */
        GetPrivateProfileString(APPGEN, "Font",font, font, sizeof(font)-1, INI_FILE);

        /* coge el fuente proporcional */
        nFont=(HANDLE) GetStockObject(SYSTEM_FONT);

        /* coge los datos del fuente actual */
        if(!GetObject(nFont, sizeof(lf), (LPSTR) &lf))
                MessageBeep(0);

	strcpy(lf.lfFaceName, strtok(font, ","));
	AltpFont=atoi(strtok(NULL, ","));
	lf.lfHeight=AltpFont;
	AltpFont+=AltpFont/6;

	lf.lfWeight=FW_HEAVY;

        pFont=CreateFontIndirect((LOGFONT FAR *) &lf);

	lf.lfWeight=FW_NORMAL;

        tFont=CreateFontIndirect((LOGFONT FAR *) &lf);

        strcpy(lf.lfFaceName, "Courier New");

        lf.lfPitchAndFamily&=0x3;
        lf.lfPitchAndFamily|=FIXED_PITCH;

        /* se crea */
        fFont=CreateFontIndirect((LOGFONT FAR *) &lf);
}


void SetInfo(void)
/* rellena la informacin en la ventana de la lista */
{
        char tmp[150];

        if(hwndLst)
        {
                /* define el estado del mensaje */
                SetDlgItemText(hwndLst, VL_ESTADO,
                        (NumMsgs==0?NULL:
                        (Msg.dat&MASK_BOR)?"Borrado":
                        (Msg.dat&MASK_LEI?"Ya ledo":"Nuevo")
                        ));

                if(NumMsgs)
                        sprintf(tmp,"[%d] %s", Msg.num, Fecha);
                else
                        tmp[0]='\0';

                SetDlgItemText(hwndLst, VL_FECHA, tmp);
        }
}


void procstr(char * cadena)
/* funcin procstr para ReadMsg */
{
	strcat(cadena,"\r\n");
}



#ifdef MM_GALLETAS
/* prototipo de btoatob, que est en la dll */
int FAR btoatob(LPSTR, LPSTR, LPSTR, LPSTR);

void ProcessMM(void)
/* procesa los objetos multimedia */
{
	HINSTANCE atobdll;
	int (FAR * btoatob)(LPSTR, LPSTR, LPSTR, LPSTR);
	int ret;
	char tmp[150];

//	MessageBox(NULL,"Este mensaje incorpora un objeto multimedia.\r\nSe encuentra en formato btoa en el fichero 'wailer.b2a'.",
//		szApp, MB_OK);

	atobdll=LoadLibrary("atob.dll");

	if(atobdll>HINSTANCE_ERROR)
	{
		if(((FARPROC) btoatob=GetProcAddress(atobdll, "btoatob"))!=NULL)
		{
			ret=btoatob((LPSTR)"a",(LPSTR)"n",
				(LPSTR)"wailer.b2a",(LPSTR)"wailer.mm");

			if(ret==0)
				SetTxtLinMsg("Objeto multimedia procesado.");
			else
				SetTxtLinMsg("Error procesando objeto multimedia.");
		}
		else
		{
			sprintf(tmp,"GetProcAddress: error");
			MessageBox(NULL,tmp,tmp,MB_OK);
		}

		FreeLibrary(atobdll);
	}
	else
	{
		sprintf(tmp,"LoadLibrary: %d",atobdll);
		MessageBox(NULL,tmp,tmp,MB_OK);
	}
}
#endif


void multipart(void)
/* funcin multipart de ReadMsg */
{
        char * content;
        char app[100];
        char tmp[250];
        FARPROC lpfnProc;
        int ret;

	/* si no tiene nombre, pues nada */
	if(thisFileName[0]=='\0')
        	return;

	content=strtok(thisContentType,"; ");

	app[0]='\0';
	SearchMIME_EXT(content,NULL,app);

	if(app[0]=='\0')
	{
		sprintf(tmp,
			"Un objeto MIME del tipo '%s'\n\nse ha grabado en FILES\\%s\n\n"\
			"Si desea lanzar automticamente una aplicacin,\n"\
			"utilice el men Opciones/Preferencias.\n",
			content, thisFileName);

		MessageBox(hwndFrame, tmp,szApp,MB_OK);
		return;
	}

	if(app[0]=='*')
	{
		sprintf(tmp,
			"Se ha encontrado sin asociacin el tipo MIME\n\n'%s'\n\nAadirla ahora?",
			content);

		if(MessageBox(hwndFrame,tmp,szApp,MB_YESNO)==IDYES)
		{
			sprintf(buffer,"%s\t\t",content);

			/* llama al cuadro de dilogo */
                        lpfnProc=MakeProcInstance(EditMimeProc,hInst);
			ret=DialogBox(hInst,"EditMime", hwndFrame, lpfnProc);
                        FreeProcInstance(lpfnProc);

			if(ret)
			{
				FILE * f;
				int n;

				for(n=0;buffer[n];n++)
				{
					if(buffer[n]=='\t')
						buffer[n]='|';
				}

				if((f=fopen(MIME_EXT, "a"))!=NULL)
                                {
					fprintf(f,"%s%s",buffer,NL_STR);

					fclose(f);
                                }
			}
		}
		else
		{
			sprintf(tmp,"El objeto MIME se ha grabado en FILES\\%s.\n",thisFileName);

			MessageBox(hwndFrame,tmp,szApp,MB_OK);
                }

		return;
	}

	sprintf(tmp,"%s FILES\\%s",app,thisFileName);

        WinExec(tmp, SW_SHOWNORMAL);
}


void CargarMensaje(void)
/* carga el texto del mensaje actual */
{
	HLOCAL h;
        WORD tmem;
        char * ptr;

	SetWindowText(hwndTexto, NULL);
        SetWindowText(hwndCabecera, NULL);
	SetWindowText(hwndMsg, "Mensaje");

	/* si no hay ningn mensaje, se vaca */
        if(Mensaje==NO_MENSAJE || NumMsgs==0)
                return;

        /* se aloca memoria */
	tmem=16000;
	h=LocalAlloc(LMEM_FIXED, tmem+1);
        ptr=LocalLock(h);

	if(ptr!=NULL)
        {
		if(Conferencia!=-1 && Mensaje!=NO_MENSAJE)
                {
			if(ReadMsg(buffer,sizeof(buffer)-1,ptr,tmem,procstr,multipart)==-1)
				SetWindowText(hwndMsg, "Mensaje (incompleto)");
			else
			if(*thisDescription!='\0')
			{
				OemToAnsi(thisDescription, thisDescription);

				SetWindowText(hwndMsg, thisDescription);
                        }
		}
	        else
	        {
	                buffer[0]=0;
	                *ptr=0;
		}
	}
	else
        {
		ptr="Memoria insuficiente para cargar mensaje.\n";
		buffer[0]=0;
	}

	SetInfo();

	if(StrCmp(thisCharset,"iso-8859-1")!=0)
	{ 
		OemToAnsi(buffer,buffer);
		OemToAnsi(ptr,ptr);
	}

        /* mete el mensaje */
	SetWindowText(hwndCabecera,buffer);
	if(SendMessage(hwndTexto, WM_SETTEXT,NULL,(DWORD)(LPSTR) ptr)==0)
		MessageBeep(0);

        /* se libera */
        LocalUnlock(h);
        LocalFree(h);

	/* lo marca como leido */
        if(Mensaje!=NO_MENSAJE)
                SetMsgFlags(MASK_LEI);
}


void NewElem(void)
/* funcin newelem de ReadList */
{
        int n;
        char forme;

        if(strcmp(Yo,Remit)==0 || strcmp(Yo,To)==0
	|| strcmp(Yo,Remit+1)==0 || strcmp(Yo,To+1)==0)
                forme='>';
        else
                forme=' ';

        sprintf(lineatmp, "%c%s\t%s\t%s", forme, Remit, To, Subject);

        OemToAnsi(lineatmp,lineatmp);

        /* aade los elementos a las listas */
	SendMessage(hwndLista, LB_ADDSTRING, 0, (LONG) (LPSTR) lineatmp);
}


void CargarLista(void)
/* carga la lista de mensajes de esta conferencia */
{
        if(hwndLista==0)
        {
                /* se enva un mensaje al men para que se active la ventana */
                SendMessage(hwndFrame, WM_COMMAND, IDM_WAILISTA, 0L);
        }

        /* se vacan las listas */
        SendMessage(hwndLista, LB_RESETCONTENT, 0, 0L);

        /* si no hay conferencia... */
        if(Conferencia==-1)
                return;

        if(!ReadList(NewElem))
        	return;

        if(!NumMsgs)
                Mensaje=NO_MENSAJE;

        if(NumMsgs && Mensaje>=(long) NumMsgs)
                Mensaje=0;

        if(NumMsgs && Mensaje==NO_MENSAJE)
                Mensaje=0;

        if(Mensaje!=NO_MENSAJE)
        {
                SendMessage(hwndLista, LB_SETCURSEL, (WORD) Mensaje, 0L);
                SendMessage(hwndLista, LB_SETTOPINDEX, (WORD) Mensaje, 0L);
        }
}


BOOL CargaConfes(HWND hwnd)
/* carga en la combobox las conferencias */
{
        int n;

        /* vaca la lista */
        SendMessage(hwnd, CB_RESETCONTENT, 0, 0L);

        /* la rellena */
        for(n=0;n<NumConfes;n++)
        {
                SendMessage(hwnd, CB_ADDSTRING, 0,
                        (LONG) (char far *) Conferencias[n]);
        }

        if(Conferencia!=-1)
        {
                /* si hay alguna conferencia, se activa */
                SendMessage(hwnd, CB_SETCURSEL, Conferencia, 0L);
                return(TRUE);
        }
        else
        {
                MessageBox(hwnd, "No hay ninguna conferencia cargada!",
                        szApp, MB_OK|MB_ICONSTOP);

                return(FALSE);
        }
}


void WriteMensaje(HWND hwnd, char * conf, char * objfile, char * objdesc)
/* escribe el mensaje */
{
        HANDLE h;
        char * ptr;
        WORD tam;

	tam=16000;
        h=LocalAlloc(LMEM_MOVEABLE, tam);
        ptr=LocalLock(h);

        SendDlgItemMessage(hwnd, VR_TEXTO, WM_GETTEXT, tam,
		(DWORD)(LPSTR) ptr);

	AnsiToOem(ptr,ptr);

	WriteMsg(ptr, conf, objfile, objdesc);

	LocalUnlock(h);
	LocalFree(h);
}


void QuoteTexto(HWND hwnd)
/* quotea el mensaje */
{
        HANDLE h;
        char * ptr;
        WORD tam;

	tam=16000;
        h=LocalAlloc(LMEM_MOVEABLE, tam);
        ptr=LocalLock(h);

	QuoteMsg(ptr, tam-1, procstr);

	OemToAnsi(ptr,ptr);
	OemToAnsi(Remit,Remit);
	OemToAnsi(Subject,Subject);

	/* rellena los cuadros */
	SetDlgItemText(hwnd, VR_TEXTO, (LPSTR) ptr);
	SetDlgItemText(hwnd, VR_A, (LPSTR) Remit);
	SetDlgItemText(hwnd, VR_TEMA, (LPSTR) Subject);

	LocalUnlock(h);
	LocalFree(h);
}


void LoadResFile(void)
/* carga el fichero de respuestas */
{
        HANDLE h;
        LPSTR ptr;
        int c;
        int n;
        FILE * f;
        long l;
        MDICREATESTRUCT mdicreate;

        if(hwndRes)
        {
                MessageBox(hwndFrame, "Slo se puede abrir un Fichero de Respuestas.",
                        szApp, MB_OK|MB_ICONEXCLAMATION);
                return;
        }

        if(NumResp)
        {
                MessageBox(hwndFrame, "No se puede abrir el Fichero de Respuestas\nmientras quede pendiente algn mensaje.",
                        szApp, MB_OK|MB_ICONEXCLAMATION);
                return;
        }

        if((f=fopen(RESP_FILE, "rb"))==NULL)
        {
                MessageBox(hwndFrame, "An no existe un Fichero de Respuestas.",
                        szApp, MB_OK|MB_ICONEXCLAMATION);
                return;
        }

        fseek(f,0,2);
        l=ftell(f);

        if(l>32000)
        {
                MessageBox(hwndFrame, "El Fichero de Respuestas no cabe en memoria.",
                        szApp, MB_OK|MB_ICONEXCLAMATION);

                fclose(f);
                return;
        }

        h=GlobalAlloc(GMEM_MOVEABLE, 32001L);
        ptr=GlobalLock(h);

        fseek(f,0,0);

        for(n=0;(c=fgetc(f))!=EOF;)
        {
                if(c=='\r')
                        continue;
                else
                if(c=='\n')
                        ptr[n++]='\r';

                ptr[n++]=(char) c;
        }
        ptr[n]=0;

        fclose(f);

        OemToAnsi(ptr,ptr);

        /* abre la ventana de escritura de respuestas */
        mdicreate.szClass=strResClass;
        mdicreate.szTitle="Edicin del Fichero de Respuestas";
        mdicreate.hOwner =hInst;
        mdicreate.x      =CW_USEDEFAULT;
        mdicreate.y      =CW_USEDEFAULT;
        mdicreate.cx     =CW_USEDEFAULT;
        mdicreate.cy     =CW_USEDEFAULT;
        mdicreate.style  =0;
        mdicreate.lParam =NULL;

        hwndRes=(HWND) SendMessage (hwndClient, WM_MDICREATE,
                0, (LONG) (LPMDICREATESTRUCT) &mdicreate);

        SetDlgItemText(hwndRes, VR_TEXTO, ptr);

        /* se libera */
        GlobalUnlock(h);
        GlobalFree(h);
}


void SaveResFile(void)
/* graba a disco el fichero de respuestas */
{
        HANDLE h;
        LPSTR ptr;
        int i;
        int l;

        if(hwndRes==0)
                return;

        h=GlobalAlloc(GMEM_MOVEABLE, 32001L);
        ptr=GlobalLock(h);

        l=GetDlgItemText(hwndRes, VR_TEXTO, ptr, 32000);

        AnsiToOem(ptr,ptr);

        i=open(RESP_FILE, O_CREAT|O_TRUNC|O_WRONLY|O_BINARY,
        	S_IREAD|S_IWRITE);
        _lwrite(i,ptr,l);
        close(i);

        /* se libera */
        GlobalUnlock(h);
        GlobalFree(h);
}


void SetUpToolBox(void)
/* pone a tono el men fichero (y los botones de la toolbox) */
{
        if(hwndToolBox)
        {
                SetWindowText(GetDlgItem(hwndToolBox, TB_BORRAR),
			(Msg.dat&MASK_BOR?"Recuperar;Recuperar mensaje.":"Borrar;Borrar mensaje."));

                EnableWindow(GetDlgItem(hwndToolBox, TB_NUEVOS), (Histo!=0));
                EnableWindow(GetDlgItem(hwndToolBox, TB_HISTORICO), (Histo!=1));
                EnableWindow(GetDlgItem(hwndToolBox, TB_RESPUESTAS), (Histo!=2));

                EnableWindow(GetDlgItem(hwndToolBox, TB_BORRAR),
                        (Mensaje!=NO_MENSAJE && NumMsgs));
                EnableWindow(GetDlgItem(hwndToolBox, TB_CONTESTAR),
                        (Mensaje!=NO_MENSAJE && NumMsgs));
        }

        CheckMenuItem(hMenu, IDM_NUEVOS, (Histo==0?MF_CHECKED:MF_UNCHECKED));
        CheckMenuItem(hMenu, IDM_HISTORICO, (Histo==1?MF_CHECKED:MF_UNCHECKED));

        EnableMenuItem(hMenu, IDM_BORRAR,
                (Mensaje!=NO_MENSAJE && NumMsgs?MF_UNCHECKED:MF_GRAYED));
        EnableMenuItem(hMenu, IDM_CONTESTAR,
                (Mensaje!=NO_MENSAJE && NumMsgs?MF_UNCHECKED:MF_GRAYED));
}



/** procedimientos de ventana **/

#ifdef LST_OWNERDRAW
void LstDrawSelection(LPDRAWITEMSTRUCT lp)
/* dibuja la seleccin */
{
        HBRUSH hb;
        RECT rc;

        CopyRect(&rc, &lp->rcItem);

        SetROP2(lp->hDC, R2_COPYPEN);

        if(lp->itemState & ODS_SELECTED || lp->itemState & ODS_FOCUS)
                hb=GetStockObject(GRAY_BRUSH);
        else
                hb=CreateSolidBrush(GetSysColor(COLOR_WINDOW));

        FrameRect(lp->hDC, &rc, hb);
        InflateRect(&rc,-1,-1);
        FrameRect(lp->hDC, &rc, hb);

        DeleteObject(hb);
}


void LstDrawItem(LPDRAWITEMSTRUCT lp)
/* dibuja un elemento de la lista */
{
        RECT rc;
        char linea[500];
        COLORREF cr;
        char tmp[100];
        int n;
        int m;

        /* coge el rectngulo */
        CopyRect(&rc, &lp->rcItem);

        if(SendMessage(hwndLista, LB_GETTEXT, (WORD) lp->itemID,
                (DWORD)(LPSTR) linea)!=LB_ERR)
        {
                if(linea[0]!=' ')
                        cr=SetTextColor(lp->hDC, RGB(0x00,0x00,0xff));

                /* pone fuente pequeo y gordo */
                SelectObject(lp->hDC, pFont);

                /* coge el texto hasta el \t */
                for(m=0,n=0;linea[n]!='\t';n++,m++)
                        tmp[m]=linea[n];
                tmp[m]=0;

                /* escribe el remitente */
                DrawText(lp->hDC, tmp, -1, &rc, DT_SINGLELINE);

                /* coge el destinatario */
                for(n++,m=0;linea[n]!='\t' && linea[n]!=0;n++,m++)
                        tmp[m]=linea[n];
                tmp[m]=0;

                /* escribe el destinatario */
                rc.left+=AltpFont*8;
                DrawText(lp->hDC, tmp, -1, &rc, DT_SINGLELINE);

                /* pone fuente pequeo y fino */
                SelectObject(lp->hDC, tFont);

                /* coge el texto hasta el \t */
                for(m=0,n++;linea[n]!='\t' && linea[n]!=0;n++,m++)
                        tmp[m]=linea[n];
                tmp[m]=0;

                /* escribe el subject */
                rc.left+=AltpFont*8;
                DrawText(lp->hDC, tmp, -1, &rc, DT_SINGLELINE);

                if(linea[0]!=' ')
                        SetTextColor(lp->hDC, cr);

                LstDrawSelection(lp);
        }
}
#endif /* LST_OWNERDRAW */


DWORD FAR PASCAL WailerLstProc(HWND hwnd, WORD msg, WORD wParam,
        DWORD lParam)
/* gestor de la lista */
{
        HWND hwndtmp;
        static int add=0;
        static int y=0;
        static int tx=0;
        static int ty=0;
        static int tctx=0;
        static int cbtx=0;
        static int fetx=0;
        DWORD l;
        LPDRAWITEMSTRUCT lp;

        switch(msg)
        {
        case WM_CREATE:

                /* pone fuente pequeo a toda la ventana de la lista */
                SendMessage(hwnd, WM_SETFONT, pFont, TRUE);

                if(add==0)
                {
                        tx=AltpFont*5;
                        tctx=AltpFont*7;
                        cbtx=AltpFont*7;
                        fetx=tctx*3;

                        ty=AltpFont*4;
                        ty/=3;

                        add=ty*3;
                        add/=2;

                        y=10+ty;
                }

                /* esttico del texto 'Conferencia' */
                hwndtmp=CreateWindow("static", "Conferencia:",
                        WS_CHILD|WS_VISIBLE|WS_BORDER|SS_CENTER,
                        5, 5, tctx, ty, hwnd, -1, hInst, NULL);
                SendMessage(hwndtmp, WM_SETFONT, pFont, TRUE);

                /* combobox de las conferencias */
                hwndtmp=CreateWindow("combobox", NULL,
			WS_CHILD|WS_VISIBLE|WS_BORDER|WS_VSCROLL|
			CBS_DROPDOWNLIST,
                        10+tctx, 5, cbtx, 200, hwnd, VR_CONFES, hInst, NULL);
                SendMessage(hwndtmp, WM_SETFONT, tFont, TRUE);

                /* carga las conferencias */
                CargaConfes(hwndtmp);

                /* esttico del texto de estado */
                hwndtmp=CreateWindow("static", NULL,
                        WS_CHILD|WS_VISIBLE|WS_BORDER|SS_CENTER,
                        15+tctx+cbtx, 5, tx, ty, hwnd, VL_ESTADO, hInst, NULL);
                SendMessage(hwndtmp, WM_SETFONT, tFont, TRUE);

                /* esttico del texto de la fecha */
                hwndtmp=CreateWindow("static", NULL,
                        WS_CHILD|WS_VISIBLE|WS_BORDER|SS_LEFT,
                        20+tctx+tx+cbtx, 5, fetx, ty, hwnd, VL_FECHA, hInst, NULL);
                SendMessage(hwndtmp, WM_SETFONT, tFont, TRUE);

                /* crea la lista */
                hwndLista=CreateWindow("listbox", NULL,
                        WS_CHILD|WS_VISIBLE|WS_BORDER|WS_VSCROLL|
                        LBS_NOTIFY|
                        LBS_NOINTEGRALHEIGHT|

#ifdef LST_OWNERDRAW
                        LBS_OWNERDRAWVARIABLE|
#else
                        LBS_USETABSTOPS|
#endif

                        LBS_HASSTRINGS,
                        0, 0, 0, 0, hwnd, VL_LISTA, hInst, NULL);

                SendMessage(hwndLista, WM_SETFONT, pFont, TRUE);

#ifndef LST_OWNERDRAW
		/* define las posiciones de tabulacin */
                {
                        int tabs[3];
                        tabs[0]=50;
                        tabs[1]=100;
                        tabs[2]=150;

                        SendMessage(hwndLista, LB_SETTABSTOPS, 3, (DWORD)(LPSTR)tabs);
                }
#endif

                /* carga los mensajes de la conferencia actual en la lista */
                CargarLista();

		SendMessage(hwndLista, LB_SETCURSEL, (WORD) Mensaje, 0L);

                return(0);

        case WM_PAINT:

            	/* dibuja el cuadro con aspecto 3D */
                {
                        RECT r;
                        HDC hdc;
                        PAINTSTRUCT ps;

                        hdc=BeginPaint(hwnd, (LPPAINTSTRUCT) &ps);

                        /* coge el rea de cliente */
                        GetClientRect(hwnd, (LPRECT) &r);

                        r.bottom=add;
                        Rect3D(hdc, &r, 0);
                        r.top--; r.left--;
                        r.bottom++; r.right++;
                        Rect3D(hdc, &r, 0);

                        EndPaint(hwnd, (LPPAINTSTRUCT) &ps);
                }

                break;

#ifdef LST_OWNERDRAW
        case WM_DRAWITEM:

		/* dibujo de la lista personalizada */
                lp=(LPDRAWITEMSTRUCT) lParam;

                if(lp->itemID!=(unsigned int) -1)
                {
                        switch(lp->itemAction)
                        {
                        case ODA_DRAWENTIRE:
                                LstDrawItem(lp);
                                break;

                        case ODA_SELECT:
                        case ODA_FOCUS:
                                LstDrawSelection(lp);
                                break;
                        }
                }

                return(0);
#endif /* LST_OWNERDRAW */

        case WM_SIZE:

                /* redimensiona la lista */
                MoveWindow(hwndLista, 0, add,
                        LOWORD(lParam), HIWORD(lParam)-add, TRUE);

                break;

        case WM_COMMAND:

                switch(wParam)
                {
                case VL_LISTA:

                        switch(HIWORD(lParam))
                        {
                        case LBN_SELCHANGE:

				l=SendDlgItemMessage(hwnd, wParam,
					LB_GETCURSEL, 0, 0L);

                                if(l!=LB_ERR && l!=(DWORD) Mensaje)
                                        Mensaje=l;

                                CargarMensaje();

                                SetUpToolBox();

                                SetFocus(hwnd);

                                break;
                        }

                        break;

                case VR_CONFES:

                        switch(HIWORD(lParam))
                        {
                        case CBN_SELCHANGE:

                            	/* coge el elemento seleccionado */
				Conferencia=(int) SendDlgItemMessage(hwnd,
					wParam, CB_GETCURSEL, 0, 0L);

                                if(Conferencia!=-1)
                                        Mensaje=NO_MENSAJE;

                                /* carga la lista */
                                CargarLista();

				CargarMensaje();

                                SetUpToolBox();

                                SetFocus(hwnd);

                                break;
                        }

                        break;
                }

                return(0);

        case WM_KEYDOWN:

                /* las pulsaciones se mandan a la rutina general
                   de procesamiento de teclas */
                ProcessKeys(wParam);
                break;

        case WM_DESTROY:
                hwndLst=hwndLista=0;

                break;
        }

        return(DefMDIChildProc(hwnd, msg, wParam, lParam));
}



DWORD FAR PASCAL WailerToolBoxProc(HWND hwnd, WORD msg,
        WORD wParam, DWORD lParam)
/* gestor del toolbox */
{
        int n;
        int m;

        switch(msg)
        {
        case WM_CREATE:

                for(n=0;tbb[n].id!=0;n+=m)
                {
                        for(m=0;m<nbtb;m++)
                        {
                               /* se crea un botn */
                               CreateWindow("IconButton", tbb[n+m].icon,
                               WS_CHILD|WS_VISIBLE, m*IB_SIZE, (n/nbtb)*IB_SIZE,
                               IB_SIZE, IB_SIZE, hwnd, tbb[n+m].id, hInst, NULL);
                        }
                }

                hwndToolBox=hwnd;
                SetUpToolBox();

                return(0);

        case WM_COMMAND:

                /* le manda la opcin equivalente */
                for(n=0;tbb[n].id!=0;n++)
                {
                        if(tbb[n].id==wParam)
                                break;
                }

                /* si es un botn de icono */
                if(tbb[n].id!=0)
                        SendMessage(hwndFrame,WM_COMMAND,tbb[n].idm,0L);

                break;

        case WM_KEYDOWN:

                /* las pulsaciones se mandan a la rutina general
                   de procesamiento de teclas */
                ProcessKeys(wParam);
                break;

        case WM_DESTROY:

                hwndToolBox=0;

                break;
        }

        return(DefMDIChildProc(hwnd, msg, wParam, lParam));
}



DWORD FAR PASCAL WailerMsgProc(HWND hwnd, WORD msg,
        WORD wParam, DWORD lParam)
/* gestor de la ventana de mensaje */
{
        int l;
        long lu;

        switch(msg)
        {
        case WM_CREATE:

                /* lee el valor de Cabecera */
                {
                        char tmp[10];

			GetPrivateProfileString(szWinPos,"Cabecera",
				"N",tmp,sizeof(tmp)-1,INI_FILE);

                        if(tmp[0]=='S' || tmp[0]=='s')
                                MsgCab=1;
                        else
                                MsgCab=0;
                }

                /* crea el visor */
                hwndTexto=CreateWindow("edit", NULL,
		WS_CHILD|WS_VISIBLE|WS_VSCROLL|WS_BORDER|ES_LEFT|
		ES_MULTILINE|ES_AUTOVSCROLL,
                0, 0, 0, 0, hwnd, 1, hInst, NULL);

                SendMessage(hwndTexto, WM_SETFONT, tFont, 0L);

                /* crea la cabecera */
                hwndCabecera=CreateWindow("edit", NULL,
                WS_CHILD|WS_VISIBLE|WS_VSCROLL|WS_BORDER|ES_LEFT|
		ES_MULTILINE|ES_AUTOVSCROLL,
                0, 0, 0, 0, hwnd, 1, hInst, NULL);

                SendMessage(hwndCabecera, WM_SETFONT, tFont, 0L);

		/* cambia los procedimientos */
                ChangeEditProcs(hwndTexto);
                ChangeEditProcs(hwndCabecera);

                SetUpToolBox();

                hwndMsg=hwnd;
                CargarMensaje();

                return(0);

        case WM_SIZE:
                if(MsgCab)
                {
                        l=HIWORD(lParam)/3;

                        /* hay cabecera y texto */
                        MoveWindow(hwndCabecera, 0, 0,
                                LOWORD(lParam), l, TRUE);
                        MoveWindow(hwndTexto, 0, l,
                                LOWORD(lParam), l*2,TRUE);
                }
                else
                {
                        /* hay slo texto (la cabecera es mnima) */
                        MoveWindow(hwndCabecera, 0, 0, 0, 0, TRUE);
                        MoveWindow(hwndTexto, 0, 0,
                                LOWORD(lParam), HIWORD(lParam),TRUE);
                }

                break;

        case WM_COPY:

		/* se le manda al control de edicin del mensaje */
		lu=SendMessage(hwndTexto, EM_GETSEL, 0, 0L);

		if(LOWORD(lu)==HIWORD(lu))
		{
                	SendMessage(hwndTexto, EM_SETSEL, 1, MAKELPARAM(0, -1));
			SendMessage(hwndTexto, WM_COPY, wParam, lParam);
			SendMessage(hwndTexto, EM_SETSEL, 1, MAKELPARAM(0, 0));
		}
		else
			SendMessage(hwndTexto, WM_COPY, wParam, lParam);

		break;

        case WM_KEYDOWN:

                /* las pulsaciones se mandan a la rutina general
                   de procesamiento de teclas */
                ProcessKeys(wParam);
                break;

        case WM_DESTROY:
                hwndTexto=hwndMsg=hwndCabecera=0;

                SetUpToolBox();

                break;
        }

        return(DefMDIChildProc(hwnd, msg, wParam, lParam));
}



DWORD FAR PASCAL WailerRspProc(HWND hwnd, WORD msg,
        WORD wParam, DWORD lParam)
/* gestor de las ventanas de respuestas */
{
        HWND hwndtmp;
        static int add=0;
        static int y=0;
        static int ty=0;
        static int tx=0;
        static int tctx=0;
        static int tatx=0;
        static int tttx=0;
        char tmp[128];

        switch(msg)
        {
        case WM_CREATE:

                /* otra ms activa */
                NumResp++;

                /* pone fuente pequeo a toda la ventana de respuesta */
                SendMessage(hwnd, WM_SETFONT, tFont, TRUE);

                if(add==0)
                {
                        tx=AltpFont*5;
			tctx=AltpFont*7;
                        tatx=AltpFont*2;
                        tttx=AltpFont*3;

                        ty=AltpFont*4;
                        ty/=3;

			add=ty*3+20;

                        y=10+ty;
                }

                /* esttico del texto 'Conferencia' */
                hwndtmp=CreateWindow("static", "Conferencia:",
                        WS_CHILD|WS_VISIBLE|WS_BORDER|ES_CENTER,
                        5, 5, tctx, ty, hwnd, -1, hInst, NULL);
                SendMessage(hwndtmp, WM_SETFONT, pFont, TRUE);

		/* conferencia */
		hwndtmp=CreateWindow("edit",
			strcmp(Conferencias[Conferencia],"guest")==0?"contactos":
				Conferencias[Conferencia],
			WS_CHILD|WS_VISIBLE|WS_BORDER|ES_LEFT|WS_TABSTOP,
			10+tctx, 5, tctx, ty, hwnd, VR_CONFES, hInst, NULL);

		SendMessage(hwndtmp, WM_SETFONT, tFont, TRUE);

                /* esttico 'A:' */
                hwndtmp=CreateWindow("static", "A:",
                        WS_CHILD|WS_VISIBLE|WS_BORDER|ES_CENTER,
                        15+tctx*2, 5, tatx, ty, hwnd, -1, hInst, NULL);
                SendMessage(hwndtmp, WM_SETFONT, pFont, TRUE);

                /* cuadro A: */
                hwndtmp=CreateWindow("edit", NULL,
			WS_CHILD|WS_VISIBLE|WS_BORDER|ES_LEFT|WS_TABSTOP,
                        20+tctx*2+tatx, 5, 300, ty, hwnd, VR_A, hInst, NULL);
                SendMessage(hwndtmp, WM_SETFONT, tFont, TRUE);

                /* botones texto */
                hwndtmp=CreateWindow("button", "Enviar",
                        WS_CHILD|WS_VISIBLE|WS_TABSTOP,
                        5, y, tx, ty, hwnd, VR_ENVIAR, hInst, NULL);
		SendMessage(hwndtmp, WM_SETFONT, tFont, TRUE);

                hwndtmp=CreateWindow("button", "Cancelar",
                        WS_CHILD|WS_VISIBLE|WS_TABSTOP,
                        5+tx, y, tx, ty, hwnd, VR_CANCELAR, hInst, NULL);
                SendMessage(hwndtmp, WM_SETFONT, tFont, TRUE);

                /* esttico 'Tema:' */
                hwndtmp=CreateWindow("static", "Tema:",
                        WS_CHILD|WS_VISIBLE|WS_BORDER|ES_CENTER,
                        10+tx*2, y, tttx, ty, hwnd, -1, hInst, NULL);
                SendMessage(hwndtmp, WM_SETFONT, pFont, TRUE);

                /* cuadro de edicin Tema: */
                hwndtmp=CreateWindow("edit", NULL,
                        WS_CHILD|WS_VISIBLE|WS_BORDER|ES_LEFT|WS_TABSTOP|ES_AUTOHSCROLL,
                        15+tx*2+tttx, y, 400, ty, hwnd, VR_TEMA, hInst, NULL);
                SendMessage(hwndtmp, WM_SETFONT, tFont, TRUE);

		hwndtmp=CreateWindow("button", "<pegar fichero>",
                        WS_CHILD|WS_VISIBLE|WS_TABSTOP,
			5, y+ty+5, 300, ty, hwnd, VR_OBJETO, hInst, NULL);
		SendMessage(hwndtmp, WM_SETFONT, tFont, TRUE);

		hwndtmp=CreateWindow("edit", "<descripcin>",
			WS_CHILD|WS_VISIBLE|WS_BORDER|WS_TABSTOP|ES_AUTOHSCROLL,
			310, y+ty+5, 300, ty, hwnd, VR_DESC, hInst, NULL);
		SendMessage(hwndtmp, WM_SETFONT, tFont, TRUE);
		EnableWindow(hwndtmp, FALSE);

		/* cuadro de edicin de texto */
                hwndtmp=CreateWindow("edit", NULL,
                WS_CHILD|WS_VISIBLE|WS_VSCROLL|WS_BORDER|ES_LEFT|
		ES_MULTILINE|ES_AUTOVSCROLL|WS_TABSTOP,
                0, 0, 0, 0, hwnd, VR_TEXTO, hInst, NULL);

                SendMessage(hwndtmp, WM_SETFONT, tFont, 0L);

                return(0);

	case WM_SETFOCUS:

                hwndtmp=GetDlgItem(hwnd, VR_A);

		SetFocus(hwndtmp);

		break;

        case WM_PAINT:

                /* dibuja el cuadro con aspecto 3D */
                {
                        RECT r;
                        HDC hdc;
                        PAINTSTRUCT ps;

                        hdc=BeginPaint(hwnd, (LPPAINTSTRUCT) &ps);

                        /* coge el rea de cliente */
                        GetClientRect(hwnd, (LPRECT) &r);

                        r.bottom=add;
                        Rect3D(hdc, &r, 0);
                        r.top--; r.left--;
                        r.bottom++; r.right++;
                        Rect3D(hdc, &r, 0);

                        EndPaint(hwnd, (LPPAINTSTRUCT) &ps);
                }

                break;

        case WM_SIZE:

                hwndtmp=GetDlgItem(hwnd, VR_TEXTO);

                MoveWindow(hwndtmp, 0, add, LOWORD(lParam),
                        HIWORD(lParam)-add,TRUE);
                break;

        case WM_CUT:
        case WM_COPY:
        case WM_PASTE:
        case WM_CLEAR:

                /* se lo mando al control de edicin del mensaje */
                SendDlgItemMessage(hwnd, VR_TEXTO, msg, wParam, lParam);
                break;

        case WM_COMMAND:

                switch(wParam)
                {
		case VR_OBJETO:

			{
				memset(&ofn, 0, sizeof(OPENFILENAME));
				tmp[0]='\0';

				ofn.lStructSize = sizeof(OPENFILENAME);
				ofn.hwndOwner = hwnd;
				ofn.lpstrFilter =
					"Todos los archivos\0*.*\0";
				ofn.nFilterIndex = 1;
				ofn.lpstrFile= tmp;
				ofn.nMaxFile = sizeof(tmp);
				ofn.lpstrTitle = "Pegar fichero en mensaje";
				ofn.Flags = OFN_PATHMUSTEXIST|OFN_HIDEREADONLY|
					OFN_NOCHANGEDIR|OFN_FILEMUSTEXIST;

				if(GetOpenFileName(&ofn))
				{
					int i;
					long l;

					lstrcpy(tmp,ofn.lpstrFile);
					i=open(tmp,O_RDONLY|O_BINARY);
					l=lseek(i,0,SEEK_END);
					close(i);

					if(l>16384 && !AnySize)
					{
						MessageBox(NULL,
						"Este fichero ocupa ms de 16 Kilobytes.\nUtilice las reas de ficheros.",
						szApp, MB_OK);
					}
					else
                                        {
						SetDlgItemText(hwnd, VR_OBJETO, ofn.lpstrFile);

						hwndtmp=GetDlgItem(hwnd, VR_DESC);
						EnableWindow(hwndtmp, TRUE);
                                        	SetWindowText(hwndtmp,"");
						SetFocus(hwndtmp);
                                        }
				}
				else
				{
					SetDlgItemText(hwnd, VR_OBJETO, "<pegar fichero>");
					SetDlgItemText(hwnd, VR_DESC, "<descripcin>");
					EnableWindow(GetDlgItem(hwnd, VR_DESC),FALSE);
                                }
			}

			break;

                case VR_ENVIAR:

			{
				char objfile[128];
				char objdesc[128];

				SendDlgItemMessage(hwnd, VR_CONFES,WM_GETTEXT,
					sizeof(tmp)-1,(DWORD) (LPSTR) tmp);
				SendDlgItemMessage(hwnd, VR_TEMA,WM_GETTEXT,
					sizeof(Subject)-1,(DWORD) (LPSTR) Subject);
				SendDlgItemMessage(hwnd, VR_A,WM_GETTEXT,
					sizeof(To)-1,(DWORD) (LPSTR) To);
				SendDlgItemMessage(hwnd, VR_OBJETO,WM_GETTEXT,
					sizeof(objfile)-1,(DWORD) (LPSTR) objfile);
				SendDlgItemMessage(hwnd, VR_DESC,WM_GETTEXT,
					sizeof(objdesc)-1,(DWORD) (LPSTR) objdesc);

				AnsiToOem(Subject, Subject);
				AnsiToOem(To, To);
				AnsiToOem(objdesc, objdesc);

				WriteMensaje(hwnd, tmp,
					objfile[0]=='<'?NULL:objfile,objdesc);
			}

                        /* no hay break aposta */

                case VR_CANCELAR:

                        SendMessage(hwnd, WM_CLOSE, 0, 0L);
                        break;
                }

                return(0);

        case WM_CLOSE:

                NumResp--;

                break;
        }

        return(DefMDIChildProc(hwnd, msg, wParam, lParam));
}


DWORD FAR PASCAL WailerResProc(HWND hwnd, WORD msg,
        WORD wParam, DWORD lParam)
/* gestor de las ventanas de edicin de todas las respuestas */
{
        HWND hwndtmp;
        static int add=0;
        static int y=0;
        static int ty=0;
        static int tx=0;
        static int tctx=0;
        static int tatx=0;
        static int tttx=0;
        char tmp[100];

        switch(msg)
        {
        case WM_CREATE:

                /* pone fuente pequeo a toda la ventana de respuesta */
                SendMessage(hwnd, WM_SETFONT, tFont, TRUE);

                if(add==0)
                {
                        tx=AltpFont*5;
                        tctx=AltpFont*7;
                        tatx=AltpFont*2;
                        tttx=AltpFont*3;

                        ty=AltpFont*4;
                        ty/=3;

                        add=ty*3;
                        add/=2;

                        y=10+ty;
                }

                /* botones texto */
                hwndtmp=CreateWindow("button", "Salvar",
                        WS_CHILD|WS_VISIBLE,
                        5, 5, tx, ty, hwnd, VR_ENVIAR, hInst, NULL);
                SendMessage(hwndtmp, WM_SETFONT, tFont, TRUE);

                hwndtmp=CreateWindow("button", "Cancelar",
                        WS_CHILD|WS_VISIBLE,
                        5+tx, 5, tx, ty, hwnd, VR_CANCELAR, hInst, NULL);
                SendMessage(hwndtmp, WM_SETFONT, tFont, TRUE);

                /* cuadro de edicin de texto */
                hwndtmp=CreateWindow("edit", NULL,
                WS_CHILD|WS_VISIBLE|WS_VSCROLL|WS_BORDER|ES_LEFT|
                ES_MULTILINE|ES_AUTOVSCROLL,
                0, 0, 0, 0, hwnd, VR_TEXTO, hInst, NULL);

                SendMessage(hwndtmp, WM_SETFONT, tFont, 0L);

                return(0);

        case WM_PAINT:

                /* dibuja el cuadro con aspecto 3D */
                {
                        RECT r;
                        HDC hdc;
                        PAINTSTRUCT ps;

                        hdc=BeginPaint(hwnd, (LPPAINTSTRUCT) &ps);

                        /* coge el rea de cliente */
                        GetClientRect(hwnd, (LPRECT) &r);

                        r.bottom=add;
                        Rect3D(hdc, &r, 0);
                        r.top--; r.left--;
                        r.bottom++; r.right++;
                        Rect3D(hdc, &r, 0);

                        EndPaint(hwnd, (LPPAINTSTRUCT) &ps);
                }

                break;

        case WM_SIZE:

                hwndtmp=GetDlgItem(hwnd, VR_TEXTO);

                MoveWindow(hwndtmp, 0, add, LOWORD(lParam),
                        HIWORD(lParam)-add,TRUE);
                break;

        case WM_CUT:
        case WM_COPY:
        case WM_PASTE:
        case WM_CLEAR:

                /* se lo mando al control de edicin del mensaje */
                SendDlgItemMessage(hwnd, VR_TEXTO, msg, wParam, lParam);
                break;

        case WM_COMMAND:

                switch(wParam)
                {
                case VR_ENVIAR:

			/* grabar el fichero de respuestas */
                        SaveResFile();

                        /* no hay break aposta */

                case VR_CANCELAR:

                        SendMessage(hwnd, WM_CLOSE, 0, 0L);
                        break;
                }
                return(0);

        case WM_CLOSE:

                hwndRes=0;

                break;
        }

        return(DefMDIChildProc(hwnd, msg, wParam, lParam));
}


void SalvaSp(void)
/* salva el aspecto */
{
        RECT fr;
        RECT rect;
        char tmp[100];
	int backtozoomed;

	backtozoomed=IsZoomed(hwndFrame);

        SendMessage(hwndFrame, WM_SYSCOMMAND, SC_RESTORE, NULL);
        GetWindowRect(hwndFrame, &fr);

        sprintf(tmp,"%d,%d,%d,%d",fr.left, fr.top, fr.right, fr.bottom);
        WritePrivateProfileString(szWinPos,"Main",tmp,INI_FILE);

        if(hwndToolBox!=NULL)
        {
                SendMessage(hwndToolBox, WM_SYSCOMMAND, SC_RESTORE, NULL);
                GetWindowRect(hwndToolBox, &rect);
                sprintf(tmp,"%d,%d,%d,%d",
                        rect.left-fr.left,rect.top-fr.top,
                        rect.right-fr.left,rect.bottom-fr.top);
                WritePrivateProfileString(szWinPos,"ToolBox",tmp,INI_FILE);
        }

        if(hwndMsg!=NULL)
        {
                SendMessage(hwndMsg, WM_SYSCOMMAND, SC_RESTORE, NULL);
                GetWindowRect(hwndMsg, &rect);
                sprintf(tmp,"%d,%d,%d,%d",
                        rect.left-fr.left,rect.top-fr.top,
                        rect.right-fr.left,rect.bottom-fr.top);
                WritePrivateProfileString(szWinPos,"Mensaje",tmp,INI_FILE);
        }

        if(hwndLst!=NULL)
        {
                SendMessage(hwndLst, WM_SYSCOMMAND, SC_RESTORE, NULL);
                GetWindowRect(hwndLst, &rect);
                sprintf(tmp,"%d,%d,%d,%d",
                        rect.left-fr.left,rect.top-fr.top,
                        rect.right-fr.left,rect.bottom-fr.top);
                WritePrivateProfileString(szWinPos,"Lista",tmp,INI_FILE);
        }

        WritePrivateProfileString(szWinPos,"Cabecera",(MsgCab==0?"N":"S"),INI_FILE);

        sprintf(tmp,"%d",nbtb);
        WritePrivateProfileString(APPGEN,"ToolBoxCols",tmp,INI_FILE);

	WritePrivateProfileString(szWinPos, "Zoomed", (backtozoomed?"S":"N"),INI_FILE);

        SendMessage(hwndFrame, WM_SYSCOMMAND, SC_MAXIMIZE, NULL);

	SetTxtLinMsg("Aspecto salvado.");
}


void SaveAs(HWND hwnd)
/* salva el mensaje a disco */
{
	FILE * f;
	FILE * o;
        long l;
	int c;

	memset(&ofn, 0, sizeof(OPENFILENAME));
	lineatmp[0]='\0';

	ofn.lStructSize=sizeof(OPENFILENAME);
	ofn.hwndOwner=hwnd;
	ofn.lpstrFilter="Archivos de texto (*.txt)\0*.txt\0Todos los archivos\0*.*\0";
	ofn.nFilterIndex=1;
	ofn.lpstrFile=lineatmp;
	ofn.nMaxFile=sizeof(lineatmp);
	ofn.lpstrTitle="Guardar mensaje";
	ofn.Flags=OFN_HIDEREADONLY|OFN_NOCHANGEDIR;

	if(GetSaveFileName(&ofn))
	{
		f=GoToDatOffset();
                l=Msg.tamcab+Msg.tambody;

		fseek(f,Msg.offset-1,0);

		o=fopen(lineatmp,"a");

		while(l)
		{
			if((c=fgetc(f))==EOF)
				break;

                        fputc(c,o);

			l--;
		}

		fclose(o);
		fclose(f);
	}
}



#pragma argsused

BOOL FAR PASCAL AcercaDeProc(HWND hDlg, WORD message, WORD wParam, LONG lParam)
/* procedimiento de cuadro de acerca de... */
{
        switch(message)
        {
        case WM_INITDIALOG:
                SetWindowText(hDlg, szApp);
                return(TRUE);

        case WM_COMMAND:
                if(wParam==IDOK)
                {
                        EndDialog(hDlg, 0);
                        return(TRUE);
                }
                break;
        }
        return(FALSE);
}


#pragma argsused

BOOL FAR PASCAL EditMimeProc(HWND hDlg, WORD message, WORD wParam, LONG lParam)
/* procedimiento de cuadro de edicin de tipos MIME */
{
	char tmp[100];

        switch(message)
        {
        case WM_INITDIALOG:

		SetDlgItemText(hDlg, EMIM_TIPO, strtok(buffer, "\t"));
		SetDlgItemText(hDlg, EMIM_EXT, strtok(NULL, "\t"));
		SetDlgItemText(hDlg, EMIM_APP, strtok(NULL, "\t"));

                return(TRUE);

        case WM_COMMAND:

		switch(wParam)
		{
		case EMIM_BUSCAR:

                        {
			memset(&ofn, 0, sizeof(OPENFILENAME));
			GetDlgItemText(hDlg, EMIM_APP, (LPSTR) tmp, sizeof(tmp)-1);

			ofn.lStructSize = sizeof(OPENFILENAME);
			ofn.hwndOwner = hDlg;
			ofn.lpstrFilter =
				"Aplicaciones\0*.exe\0";
			ofn.nFilterIndex = 1;
			ofn.lpstrFile= tmp;
			ofn.nMaxFile = sizeof(tmp);
			ofn.lpstrTitle = "Aplicaciones";
			ofn.Flags = OFN_PATHMUSTEXIST|OFN_HIDEREADONLY|
				OFN_NOCHANGEDIR|OFN_FILEMUSTEXIST;

			if(GetOpenFileName(&ofn))
				SetDlgItemText(hDlg, EMIM_APP, ofn.lpstrFile);

                        }
			break;

		case IDCANCEL:

			EndDialog(hDlg, 0);
			return(TRUE);

                case IDOK:

                	buffer[0]='\0';

			GetDlgItemText(hDlg, EMIM_TIPO, (LPSTR) tmp, sizeof(tmp));
			strcat(buffer, tmp);
			strcat(buffer, "\t");
			 
			GetDlgItemText(hDlg, EMIM_EXT, (LPSTR) tmp, sizeof(tmp));
			strcat(buffer, tmp);
			strcat(buffer, "\t");
			 
			GetDlgItemText(hDlg, EMIM_APP, (LPSTR) tmp, sizeof(tmp));
			strcat(buffer, tmp);

			EndDialog(hDlg, 1);
                        return(TRUE);
		}

		break;
        }
        return(FALSE);
}


#pragma argsused

BOOL FAR PASCAL PrefProc(HWND hDlg, WORD message, WORD wParam, LONG lParam)
/* procedimiento de cuadro de preferencias... */
{
	FILE * f;
	char tmp[100];
        int n,m,i;
        int ret;
	FARPROC lpfnProc;

        switch(message)
        {
        case WM_INITDIALOG:

		SetDlgItemText(hDlg, PRF_YO, Yo);
		SetDlgItemText(hDlg, PRF_MENSAJES, MSG_FILE);
		SetDlgItemText(hDlg, PRF_CONTESTA, RESP_FILE);

		SendDlgItemMessage(hDlg, PRF_MIMELISTA, WM_SETFONT, fFont, TRUE);

		/* define las posiciones de tabulacin */
                {
                        int tabs[3];
			tabs[0]=60;
                        tabs[1]=120;
			tabs[2]=170;

			SendDlgItemMessage(hDlg, PRF_MIMELISTA,
				LB_SETTABSTOPS, 3, (DWORD)(LPSTR)tabs);
		}

		DefaultMIME_EXT();

		if((f=fopen(MIME_EXT, "r"))!=NULL)
		{
			for(;;)
			{
				if((fgets(tmp, sizeof(tmp), f))==NULL)
					break;

				tmp[strlen(tmp)-1]='\0';

				if(tmp[0]=='[' || tmp[0]==';' || tmp[0]=='\0')
					continue;

				for(n=0;tmp[n];n++)
				{
					if(tmp[n]=='|')
						tmp[n]='\t';
				}

				SendDlgItemMessage(hDlg, PRF_MIMELISTA,
					LB_ADDSTRING, 0, (DWORD) (LPSTR) tmp);
			}

			fclose(f);

			SendDlgItemMessage(hDlg, PRF_MIMELISTA, LB_SETCURSEL, 0, 0L);
		}

		return(TRUE);

        case WM_COMMAND:

		switch(wParam)
		{
		case PRF_MIMELISTA:

			n=SendDlgItemMessage(hDlg, PRF_MIMELISTA, LB_GETCURSEL, 0, 0L);
			SendDlgItemMessage(hDlg, PRF_MIMELISTA, LB_GETTEXT, n, (DWORD) (LPSTR) tmp);

			break;
			 
		case PRF_MIMENUEVO:

			buffer[0]='\0';

			/* llama al cuadro de dilogo */
                        lpfnProc=MakeProcInstance(EditMimeProc,hInst);
			ret=DialogBox(hInst,"EditMime", hDlg, lpfnProc);
                        FreeProcInstance(lpfnProc);

			if(ret)
				SendDlgItemMessage(hDlg, PRF_MIMELISTA, LB_ADDSTRING,
					0, (DWORD) (LPSTR) buffer);

			break;

		case PRF_MIMEMODIF:

			n=SendDlgItemMessage(hDlg, PRF_MIMELISTA, LB_GETCURSEL, 0, 0L);
			SendDlgItemMessage(hDlg, PRF_MIMELISTA, LB_GETTEXT, n,
				(DWORD) (LPSTR) buffer);

			/* llama al cuadro de dilogo */
                        lpfnProc=MakeProcInstance(EditMimeProc,hInst);
			ret=DialogBox(hInst,"EditMime", hDlg, lpfnProc);
                        FreeProcInstance(lpfnProc);

			if(ret)
			{
				SendDlgItemMessage(hDlg, PRF_MIMELISTA, LB_DELETESTRING,
					n, 0L);

				SendDlgItemMessage(hDlg, PRF_MIMELISTA, LB_INSERTSTRING,
					n, (DWORD) (LPSTR) buffer);
                        }

			break;

		case IDOK:

			GetDlgItemText(hDlg, PRF_YO, Yo, sizeof(Yo));
			GetDlgItemText(hDlg, PRF_MENSAJES, MSG_FILE, sizeof(MSG_FILE));
			GetDlgItemText(hDlg, PRF_CONTESTA, RESP_FILE, sizeof(RESP_FILE));

			WritePrivateProfileString(APPGEN,"Yo",Yo,INI_FILE);
			WritePrivateProfileString(APPGEN,"FicheroMensajes",MSG_FILE,INI_FILE);
			WritePrivateProfileString(APPGEN,"FicheroRespuestas",RESP_FILE,INI_FILE);

			if((f=fopen(MIME_EXT, "w"))!=NULL)
			{
				m=SendDlgItemMessage(hDlg,PRF_MIMELISTA,LB_GETCOUNT, 0, 0L);

				for(n=0;n<m;n++)
				{
					SendDlgItemMessage(hDlg, PRF_MIMELISTA,
						LB_GETTEXT, n, (DWORD) (LPSTR) tmp);

					for(i=0;tmp[i];i++)
					{
						if(tmp[i]=='\t')
							tmp[i]='|';
					}

					fprintf(f,"%s\n",tmp);
				}

				fclose(f);
			}

			/* no hay break aposta */

                case IDCANCEL:

                        EndDialog(hDlg, 0);
                        return(TRUE);
		}

		break;
        }
        return(FALSE);
}



DWORD FAR PASCAL WailerFrameProc(HWND hwnd, WORD msg,
        WORD wParam, DWORD lParam)
/* procedimiento de ventana del 'marco' */
{
        CLIENTCREATESTRUCT cc;
        MDICREATESTRUCT mdicreate;
        long l;
        static char strtmp[80];
        HWND hwndtmp;
	static int add;

        switch(msg)
        {
        case WM_CREATE:

                /* crea la ventana cliente MDI */
                cc.hWindowMenu=NULL;
                cc.idFirstChild=IDM_FIRSTCHILD;

                hwndClient=CreateWindow("MDICLIENT", NULL,
                        WS_CHILD | WS_CLIPCHILDREN | WS_VISIBLE,
                        0, 0, 0, 0, hwnd, 1, hInst, (LPSTR) &cc);

                BuildFonts();

		SendMessage(hwnd, WM_SETFONT, tFont, TRUE);

		add=AltpFont*3;
		add/=2;

                SetUpToolBox();

                break;

        case WM_SIZE:

                MoveWindow(hwndClient, 0, 0, LOWORD(lParam),
                        HIWORD(lParam)-add,TRUE);

                return(0);

		case WM_PAINT:

                /* dibuja el cuadro con aspecto 3D de la barra de mensaje */
                {
                        RECT r;
                        HDC hdc;
                        PAINTSTRUCT ps;

                        hdc=BeginPaint(hwnd, (LPPAINTSTRUCT) &ps);

			SelectObject(hdc, tFont);
			SetBkColor(hdc, 0x00C0C0C0);

                        /* coge el rea de cliente */
                        GetClientRect(hwnd, (LPRECT) &r);

			r.top=r.bottom-add;
			FillRect(hdc, &r, GetStockObject(LTGRAY_BRUSH));
                        InflateRect(&r,1,1);
                        Rect3D(hdc, &r, 2);
			InflateRect(&r,-5,-5);

			DrawText(hdc,TxtLinMsg,strlen(TxtLinMsg),
				&r,DT_SINGLELINE);

                        EndPaint(hwnd, (LPPAINTSTRUCT) &ps);
                }

                return(0);

        case WM_COMMAND:
                switch(wParam)
                {
                case IDM_NUEVOS:

                        Histo=0;
                        SetUpToolBox();
                        Mensaje=NO_MENSAJE;
                        CargarLista();
			CargarMensaje();

                        break;

                case IDM_HISTORICO:

                        Histo=1;
                        SetUpToolBox();
                        Mensaje=NO_MENSAJE;
                        CargarLista();
			CargarMensaje();

                        break;

                case IDM_RESPUESTAS:

                        LoadResFile();

                        return(0);

                case IDM_REINDEX:

			Reindex();
               		break;

                case IDM_PACK:

                        Stop();
                        break;

		case IDM_SAVEAS:

			SaveAs(hwnd);
			break;

                case IDM_ACERCADE:

                        {
                                FARPROC lpfnProc;

                                /* llama al cuadro de dilogo */
/*                              lpfnProc=MakeProcInstance(AcercaDeProc,hInst);
                                DialogBox(hInst,"AcercaDeWailer", hwndFrame, lpfnProc);
                                FreeProcInstance(lpfnProc);
*/
				DialogBox(hInst,"AcercaDeWailer",hwndFrame,AcercaDeProc);
			}

                        break;

                case IDM_SALIR:
                        SendMessage(hwnd, WM_CLOSE, 0, 0L);
                        break;

                case IDM_CORTAR:

                        /* enva el mensaje a la ventana MDI activa */
                        SendMessage(LOWORD(SendMessage
                                (hwndClient, WM_MDIGETACTIVE, 0, 0L)),
                                WM_CUT, 0, 0L);
                        break;

                case IDM_COPIAR:

                        /* enva el mensaje a la ventana MDI activa */
			SendMessage(hwndMsg, WM_COPY, 0, 0L);
                        break;

                case IDM_PEGAR:

                        /* enva el mensaje a la ventana MDI activa */
			SendMessage(LOWORD(SendMessage
				(hwndClient, WM_MDIGETACTIVE, 0, 0L)),
                                WM_PASTE, 0, 0L);
                        break;

                case IDM_DELETE:

                        /* enva el mensaje a la ventana MDI activa */
                        SendMessage(LOWORD(SendMessage
                                (hwndClient, WM_MDIGETACTIVE, 0, 0L)),
                                WM_CLEAR, 0, 0L);
                        break;

                case IDM_OBJETO:

                        Stop();
                        break;

                case IDM_IMPRIMIR:

			if(hwndTexto)
                                PrintMsg(hwndTexto);

                        break;

		case IDM_PREF:

                        {
                                FARPROC lpfnProc;

                                /* llama al cuadro de dilogo */
                                lpfnProc=MakeProcInstance(PrefProc,hInst);
				DialogBox(hInst,"WailerPref", hwndFrame, lpfnProc);
                                FreeProcInstance(lpfnProc);
                        }

                        break;

		case IDM_CABECERA:

                        /* invierte el flag de cabecera */
                        MsgCab^=1;

                        /* checkea el men */
                        CheckMenuItem(hMenu, IDM_CABECERA,
                                (MsgCab?MF_CHECKED:MF_UNCHECKED));

                        /* fuerza un 'redibujo' */
                        SendMessage(hwndMsg, WM_SYSCOMMAND, SC_MINIMIZE, 0L);
                        SendMessage(hwndMsg, WM_SYSCOMMAND, SC_RESTORE, 0L);
                        break;

		case IDM_TBNOR:

			SendMessage(hwndToolBox, WM_CLOSE, 0,0L);
			nbtb=3;
			SendMessage(hwnd, WM_COMMAND, IDM_WAITOOLBOX, 0L);

			break;

		case IDM_TBHOR:

			SendMessage(hwndToolBox, WM_CLOSE, 0,0L);
			nbtb=12;
			SendMessage(hwnd, WM_COMMAND, IDM_WAITOOLBOX, 0L);

			break;

		case IDM_TBVER:

			SendMessage(hwndToolBox, WM_CLOSE, 0,0L);
			nbtb=1;
			SendMessage(hwnd, WM_COMMAND, IDM_WAITOOLBOX, 0L);

			break;

                case IDM_SALVASP:

                        SalvaSp();
                        break;

                case IDM_CASCADA:
                        SendMessage(hwndClient, WM_MDICASCADE, 0, 0L);
                        return 0;

                case IDM_MOSAICO:
                        SendMessage(hwndClient, WM_MDITILE, 0, 0L);
                        return 0;

                case IDM_ICONOS:
                        SendMessage(hwndClient, WM_MDIICONARRANGE, 0, 0L);
                        return 0;

                case IDM_BORRAR:

			if(NumMsgs!=0)
			{
                        	SetMsgFlags(MASK_BOR);
                        	SetInfo();
                        	SetUpToolBox();
                        }

			/* falls through */


                case IDM_AVA:

			/* siguiente mensaje */

                        /* si no est abierta... */
                        if(hwndLst==0)
                                SendMessage(hwnd, WM_COMMAND, IDM_WAILISTA, 0L);

			if(Mensaje<NumMsgs-1)
			{
                        	SendDlgItemMessage(hwndLst, VL_LISTA, WM_KEYDOWN,
                                VK_DOWN, 0L);

                        	break;
                        }

                        /* si no se cumple el if anterior,
                           falls through */


                case IDM_ADELANTE:

			/* siguiente conferencia */

                        /* si no est abierta... */
                        if(hwndLst==0)
                                SendMessage(hwnd, WM_COMMAND, IDM_WAILISTA, 0L);

                        for(;;)
                        {
                                SendDlgItemMessage(hwndLst, VR_CONFES, WM_KEYDOWN,
                                        VK_DOWN, 0L);

                                if(NumMsgs!=0 || Conferencia==NumConfes-1)
                                        break;
                        }

                        break;

                case IDM_RET:

                        /* anterior mensaje */

                        /* si no est abierta... */
                        if(hwndLst==0)
                                SendMessage(hwnd, WM_COMMAND, IDM_WAILISTA, 0L);

			if(Mensaje>0)
			{
				SendDlgItemMessage(hwndLst, VL_LISTA, WM_KEYDOWN,
                                VK_UP, 0L);

				break;
                        }

			/* si no se cumple el if anterior,
			   falls through */

                case IDM_ATRAS:

                        /* anterior conferencia */

                        /* si no est abierta... */
                        if(hwndLst==0)
                                SendMessage(hwnd, WM_COMMAND, IDM_WAILISTA, 0L);

                        for(;;)
                        {
                                SendDlgItemMessage(hwndLst, VR_CONFES, WM_KEYDOWN,
                                        VK_UP, 0L);

                                if(NumMsgs!=0 || Conferencia<=0)
                                        break;
                        }

                        break;

                case IDM_CONTESTAR:

                        /* si estn en edicin las respuestas, no se puede */
                        if(hwndRes!=0)
                        {
                                MessageBox(hwndFrame,
                                "No se puede contestar hasta que no se cierre la\nventana de Edicin del Fichero de Respuestas.",
                                szApp, MB_OK|MB_ICONEXCLAMATION);
                        }
                        else
                        {
				/* abre la ventana de escritura en contestacin */
                                sprintf(strtmp,"Respuesta al Mensaje %d",Msg.num);

                                mdicreate.szClass=strRspClass;
                                mdicreate.szTitle=strtmp;
                                mdicreate.hOwner =hInst;
                                mdicreate.x      =CW_USEDEFAULT;
                                mdicreate.y      =CW_USEDEFAULT;
                                mdicreate.cx     =CW_USEDEFAULT;
                                mdicreate.cy     =CW_USEDEFAULT;
                                mdicreate.style  =0;
                                mdicreate.lParam =NULL;

                                hwndtmp=(HWND) SendMessage (hwndClient, WM_MDICREATE,
                                0, (LONG) (LPMDICREATESTRUCT) &mdicreate);

                                QuoteTexto(hwndtmp);
                        }

                        return(0);

		case IDM_ESCRIBIR:
                        /* si estn en edicin las respuestas, no se puede */
                        if(hwndRes!=0)
                        {
                                MessageBox(hwndFrame,
                                "No se puede escribir hasta que no se cierre la\nventana de Edicin del Fichero de Respuestas.",
                                szApp, MB_OK|MB_ICONEXCLAMATION);
                        }
                        else
                        {
                                /* abre la ventana de escritura */
                                sprintf(strtmp,"Escribir Mensaje %d",EscrMsgNum++);

                                mdicreate.szClass=strRspClass;
                                mdicreate.szTitle=strtmp;
                                mdicreate.hOwner =hInst;
                                mdicreate.x      =CW_USEDEFAULT;
                                mdicreate.y      =CW_USEDEFAULT;
                                mdicreate.cx     =CW_USEDEFAULT;
                                mdicreate.cy     =CW_USEDEFAULT;
                                mdicreate.style  =0;
                                mdicreate.lParam =NULL;

                                SendMessage (hwndClient, WM_MDICREATE,
                                0, (LONG) (LPMDICREATESTRUCT) &mdicreate);
                        }

                        return(0);

		case IDM_FONT:

			/* cambia el fuente de proporcional a no */
			if(GetMenuState(hMenu, IDM_FONT,
				MF_BYCOMMAND)==MF_CHECKED)
			{
				CheckMenuItem(hMenu, IDM_FONT, MF_UNCHECKED);
				SendMessage(hwndTexto, WM_SETFONT, tFont, 0L);
			}
			else
			{
				CheckMenuItem(hMenu, IDM_FONT, MF_CHECKED);
				SendMessage(hwndTexto, WM_SETFONT, fFont, 0L);
			}

			break;

                case IDM_WAITOOLBOX:

                        /* abre la toolbox */
                        if(hwndToolBox==0)
                        {
                                char tmp[100];

                                /* abre la ventana */
				if(nbtb>12 || nbtb<1
				   || 12%nbtb!=0)
				      nbtb=3;

                                GetWpos("ToolBox");
                                mdicreate.szClass=strToolBoxClass;
                                mdicreate.szTitle="ToolBox";
                                mdicreate.hOwner =hInst;
                                mdicreate.x      =Wpos.left;
                                mdicreate.y      =Wpos.top;
                                mdicreate.cx     =nbtb*IB_SIZE+2;
                                mdicreate.cy     =(12/nbtb)*IB_SIZE+GetSystemMetrics(SM_CYCAPTION);
                                mdicreate.style  =WS_MINIMIZE;
                                mdicreate.lParam =NULL;

                                hwndToolBox=(HWND) SendMessage (hwndClient, WM_MDICREATE,
                                0, (LONG) (LPMDICREATESTRUCT) &mdicreate);

                                /* redefine las caractersticas de la ventana */
                                l=GetWindowLong(hwndToolBox, GWL_STYLE);

                                /* niega las caractersticas no deseadas */
                                l&=~WS_MAXIMIZEBOX;
                                l&=~WS_MINIMIZEBOX;
                                l&=~WS_SYSMENU;
                                l&=~WS_THICKFRAME;

                                /* redefine el tipo de ventana */
                                SetWindowLong(hwndToolBox, GWL_STYLE,l);

                                /* se restaura */
                                SendMessage(hwndToolBox, WM_SYSCOMMAND, SC_RESTORE, 0L);
                        }
                        else
                                /* hace activa la toolbox */
                                SendMessage(hwndClient, WM_MDIACTIVATE, hwndToolBox, 0L);

                        break;

                case IDM_WAILISTA:

                        /* abre la lista */
                        if(hwndLst==0)
                        {
                                /* abre la ventana */
                                GetWpos("Lista");
                                mdicreate.szClass=strLstClass;
                                mdicreate.szTitle="Lista de Mensajes";
                                mdicreate.hOwner =hInst;
                                mdicreate.x      =Wpos.left;
                                mdicreate.y      =Wpos.top;
                                mdicreate.cx     =Wpos.right;
                                mdicreate.cy     =Wpos.bottom;
                                mdicreate.style  =0;
                                mdicreate.lParam =NULL;

                                hwndLst=(HWND) SendMessage (hwndClient, WM_MDICREATE,
                                0, (LONG) (LPMDICREATESTRUCT) &mdicreate);
                        }
                        else
                                /* hace activa la lista */
                                SendMessage(hwndClient, WM_MDIACTIVATE, hwndLst, 0L);

                        SetUpToolBox();

                        break;

                case IDM_WAIMENSAJES:
                        if(hwndMsg==0)
                        {
                                /* abre la ventana de mensaje */
                                GetWpos("Mensaje");
                                mdicreate.szClass=strMsgClass;
                                mdicreate.szTitle="Mensaje";
                                mdicreate.hOwner =hInst;
                                mdicreate.x      =Wpos.left;
                                mdicreate.y      =Wpos.top;
                                mdicreate.cx     =Wpos.right;
                                mdicreate.cy     =Wpos.bottom;
                                mdicreate.style  =0;
                                mdicreate.lParam =NULL;

                                hwndMsg=(HWND) SendMessage (hwndClient, WM_MDICREATE,
                                0, (LONG) (LPMDICREATESTRUCT) &mdicreate);
                        }
                        else
                                /* hace activa la ventana de mensajes */
                                SendMessage(hwndClient, WM_MDIACTIVATE, hwndMsg, 0L);

                        return(0);
		}
                break;

	case WM_CLOSE:

		if(NumResp)
                {
			if(MessageBox(hwnd,
				"An quedan mensajes pendientes de enviar.\nSeguro que desea abandonar?",
				szApp, MB_YESNO)==IDNO)
				return(0);
                }

		DestroyWindow(hwnd);
                break;

	case WM_DESTROY:

		PostQuitMessage(0);
		return(0);
        }

        return(DefFrameProc(hwnd, hwndClient, msg, wParam, lParam));
}



int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
                    LPSTR lpszCmdLine, int nCmdShow)
/* Funcin principal */
{
        MSG msg;
        WNDCLASS wndclass;
	char tmp[130];

	Ctl3dRegister(hInstance);
	Ctl3dAutoSubclass(hInstance);

	if(*lpszCmdLine!=0)
                lstrcpy((LPSTR) INI_FILE, lpszCmdLine);

        if (hPrevInstance)
        {
                MessageBox(NULL,
                        "Ya se est ejecutando otra copia de The Wailer.",
                        szApp,MB_OK);
                return(0);
        }

        hInst=hInstance;

        /* registra los botones de icono */
        IBReg(hInstance);

        /* crea la clase de ventana 'marco' */
        wndclass.style         = CS_HREDRAW | CS_VREDRAW;
        wndclass.lpfnWndProc   = (WNDPROC) WailerFrameProc;
        wndclass.cbClsExtra    = 0;
        wndclass.cbWndExtra    = 0;
        wndclass.hInstance     = hInstance;
        wndclass.hIcon         = LoadIcon(hInst, "Wailer");
        wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
        wndclass.hbrBackground = COLOR_APPWORKSPACE + 1;
        wndclass.lpszMenuName  = NULL;
        wndclass.lpszClassName = strFrameClass;

        RegisterClass (&wndclass);

        /* crea la clase de ventana toolbox */
        wndclass.style          = CS_HREDRAW | CS_VREDRAW;
        wndclass.lpfnWndProc    = (WNDPROC) WailerToolBoxProc;
        wndclass.cbClsExtra     = 0;
        wndclass.cbWndExtra     = 0;
        wndclass.hInstance      = hInstance;
        wndclass.hIcon          = LoadIcon(hInst, "Waitool");
        wndclass.hCursor        = LoadCursor (NULL, IDC_ARROW);
        wndclass.hbrBackground  = COLOR_BTNFACE + 1;
        wndclass.lpszMenuName   = NULL;
        wndclass.lpszClassName  = strToolBoxClass;

        RegisterClass (&wndclass);

        /* crea la clase de ventana mensaje */
        wndclass.style          = CS_HREDRAW | CS_VREDRAW;
        wndclass.lpfnWndProc    = (WNDPROC) WailerMsgProc;
        wndclass.cbClsExtra     = 0;
        wndclass.cbWndExtra     = 0;
        wndclass.hInstance      = hInstance;
        wndclass.hIcon          = LoadIcon(hInst, "Escribir");
        wndclass.hCursor        = LoadCursor (NULL, IDC_ARROW);
        wndclass.hbrBackground  = COLOR_BTNFACE + 1;
        wndclass.lpszMenuName   = NULL;
        wndclass.lpszClassName  = strMsgClass;

        RegisterClass (&wndclass);

        /* crea la clase de ventana respuesta */
        wndclass.style          = CS_HREDRAW | CS_VREDRAW;
        wndclass.lpfnWndProc    = (WNDPROC) WailerRspProc;
        wndclass.cbClsExtra     = 0;
        wndclass.cbWndExtra     = 0;
        wndclass.hInstance      = hInstance;
        wndclass.hIcon          = LoadIcon(hInst, "Contestar");
        wndclass.hCursor        = LoadCursor (NULL, IDC_ARROW);
        wndclass.hbrBackground  = COLOR_BTNFACE + 1;
        wndclass.lpszMenuName   = NULL;
        wndclass.lpszClassName  = strRspClass;

        RegisterClass (&wndclass);

        /* crea la clase de ventana de edicin de respuestas */
        wndclass.style          = CS_HREDRAW | CS_VREDRAW;
        wndclass.lpfnWndProc    = (WNDPROC) WailerResProc;
        wndclass.cbClsExtra     = 0;
        wndclass.cbWndExtra     = 0;
        wndclass.hInstance      = hInstance;
        wndclass.hIcon          = LoadIcon(hInst, "Wairesp");
        wndclass.hCursor        = LoadCursor (NULL, IDC_ARROW);
        wndclass.hbrBackground  = COLOR_BTNFACE + 1;
	wndclass.lpszMenuName   = NULL;
        wndclass.lpszClassName  = strResClass;

        RegisterClass (&wndclass);

        /* crea la clase de ventana lista */
        wndclass.style          = CS_HREDRAW | CS_VREDRAW;
        wndclass.lpfnWndProc    = (WNDPROC) WailerLstProc;
        wndclass.cbClsExtra     = 0;
        wndclass.cbWndExtra     = 0;
        wndclass.hInstance      = hInstance;
        wndclass.hIcon          = LoadIcon(hInst, "Wailst");
        wndclass.hCursor        = LoadCursor (NULL, IDC_ARROW);
        wndclass.hbrBackground  = COLOR_BTNFACE + 1;
        wndclass.lpszMenuName   = NULL;
        wndclass.lpszClassName  = strLstClass;

        RegisterClass (&wndclass);

	GetPrivateProfileString(APPGEN,"ToolBoxCols","3",
       		tmp,sizeof(tmp)-1,INI_FILE);
	nbtb=atoi(tmp);

	GetPrivateProfileString(APPGEN,"Ignorar","",KillFile,sizeof(KillFile)-1,INI_FILE);

	GetPrivateProfileString(APPGEN,"MimeAnySize","*",
       		tmp,sizeof(tmp)-1,INI_FILE);

	if(*tmp!='*')
		AnySize=1;

	/* carga el men */
        hMenu=LoadMenu(hInst, "WailerMenu");

        /* crea la ventana marco */
        GetWpos("Main");
        hwndFrame=CreateWindow(strFrameClass, szApp,
                WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
                Wpos.left, Wpos.top, Wpos.right, Wpos.bottom,
                NULL, hMenu, hInstance, NULL);

        ShowWindow (hwndFrame, nCmdShow);
        UpdateWindow (hwndFrame);

       	GetPrivateProfileString(szWinPos,"Zoomed","N",
        		tmp,sizeof(tmp)-1,INI_FILE);

	if(tmp[0]=='s' || tmp[0]=='S')
		SendMessage(hwndFrame, WM_SYSCOMMAND, SC_MAXIMIZE, NULL);

        if(InitWailer(hwndFrame))
        {
        	char tmp[40];

        	sprintf(tmp,"%d nuevos, %d personales",
        		Stats.mensajes, Stats.personales);
        	SetTxtLinMsg(tmp);
        }
	else
		SetTxtLinMsg("The Wailer - Lector de correo offline / CRCOK BBS (91) 3144075");

       /* si existe alguna conferencia pero no hay ninguna
          seleccionada, pues se hace activa la primera */
       if(NumConfes && Conferencia==-1)
               Conferencia=0;

       SendMessage(hwndFrame,WM_SETFONT,pFont,TRUE);

       SendMessage(hwndFrame,WM_COMMAND,IDM_WAILISTA,0L);
       SendMessage(hwndFrame,WM_COMMAND,IDM_WAITOOLBOX,0L);
       SendMessage(hwndFrame,WM_COMMAND,IDM_WAIMENSAJES,0L);

       while (GetMessage (&msg, NULL, 0, 0))
       {
                TranslateMessage (&msg);
                DispatchMessage (&msg);
       }

       EndWailer();

       return (msg.wParam);
}
